<template>
  <div>
    <v-text-field
      v-model="search"
      label="Buscar"
      flat
      class="mr-2 ml-2"
      append-icon="mdi-magnify"
      clear-icon="mdi-close-circle-outline"
    />
    <tree
      ref="tree"
      class="tree-size"
      v-model="modelTree"
      @tree:mounted="mounted($event)"
      @node:selected="selectedNode"
      @node:unselected="unselectedNode"
      @node:added="addedNode"
      :data="data"
      :filter="search"
      :options="treeOptions"
    />
    <template v-if="modelTree">
      {{ modelTree.data }}
    </template>
  </div>
</template>
<style scoped>
.tree-size {
  overflow: auto;
  max-height: 440px;
  min-height: 440px;
}
</style>
<script>
const eventsList = [
  { name: "tree:mounted", args: ["Tree Component"] },
  { name: "tree:filtered", args: ["Matches", "Filter String"] },
  { name: "tree:data:fetch", args: ["Parent Node"] },
  { name: "tree:data:received", args: ["Parent Node"] },
  { name: "node:clicked", args: ["Node"] },
  { name: "node:disabled", args: ["Node"] },
  { name: "node:enabled", args: ["Node"] },
  { name: "node:shown", args: ["Node"] },
  { name: "node:hidden", args: ["Node"] },
  { name: "node:dblclick", args: ["Node"] },
  { name: "node:selected", args: ["Node"] },
  { name: "node:unselected", args: ["Node"] },
  { name: "node:checked", args: ["Node"] },
  { name: "node:unchecked", args: ["Node"] },
  { name: "node:expanded", args: ["Node"] },
  { name: "node:collapsed", args: ["Node"] },
  { name: "node:dragging:start", args: ["Node"] },
  { name: "node:dragging:finish", args: ["Node"] },
  { name: "node:added", args: ["Node", "New Node"] },
  { name: "node:removed", args: ["Node"] },
  { name: "node:text:changed", args: ["Node", "New Text", "Old Text"] },
  { name: "node:editing:start", args: ["Node"] },
  { name: "node:editing:stop", args: ["Node", "isTextChanged"] },
];
const treeOptions = {
  filtering: true,
  propertyNames: {
    text: "nombre",
    state: "props",
  },
  filter: {
    emptyText: "Sin resultados",
    showChildren: false,
  },
  dnd: {
    onDragFinish(targetNode, destinationNode, postion) {
      if (destinationNode.depth == 0 && postion != "drag-on") {
        return false;
      }
      if (
        destinationNode.parent &&
        targetNode.parent &&
        destinationNode.parent.id === targetNode.parent.id &&
        postion != "drag-on"
      ) {
        return false;
      }
      let nodeTarget;
      if (postion != "drag-on") {
        nodeTarget = destinationNode.parent;
      } else {
        nodeTarget = destinationNode;
      }
      self.putView(targetNode, targetNode.parent, nodeTarget);
      return true;
    },
  },
};
let self;
let key = 0;
import store from "@/store";
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-ArbolVistas",
  data: () => ({
    data: [],
    allNodes: [],
    modelTree: null,
    nodeSelected: null,
    instanceTree: null,
    search: null,
    events: [],
    loading: false,
  }),
  filters: {
    time(time) {
      return +time;
    },
  },
  computed: {
    eventsList() {
      return this.events.concat().reverse();
    },
    treeOptions() {
      return treeOptions;
    },
  },
  methods: {
    addedNode() {
      this.allNodes = [];
      let allNodes = this.instanceTree.findAll({});
      allNodes.forEach((item) => {
        this.allNodes.push(item);
      });
    },
    selectRootNode() {
      let event = new Event("click");
      let nodeSelected = this.$refs.tree.model[0];
      if (nodeSelected) {
        nodeSelected.unselect();
        nodeSelected.select(event);
      }
    },
    mounted() {
      eventsList.forEach((e) => {
        this.$refs.tree.$on(e.name, this.initEventViewer(e));
      });
      this.instanceTree = this.$refs.tree;
      this.getArbolVistas();
    },
    putView(node, originNode, targetNode) {
      let vista = node.data;
      let body = {
        idVistaPadre: targetNode.data.idVista,
      };
      axios
        .put("/accesos/sistema/vistas/v1/" + vista.idVista + "/padre", body)
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
          if (targetNode.children.length > 0) {
            targetNode.children.forEach((item) => {
              if (item.id == node.id) {
                item.remove();
              }
            });
          }
          originNode.append(node);
        });
    },
    getNodeById(id) {
      let result = this.allNodes.filter((item) => item.id == id)[0];
      if (result) {
        return result;
      } else {
        return null;
      }
    },
    selectedNode(event) {
      this.nodeSelected = event;
      setTimeout(() => {
        this.$emit("input", this.nodeSelected);
      }, 50);
    },
    unselectedNode(event) {
      this.nodeSelected = null;
      this.$emit("input", null);
    },
    initEventViewer(event) {
      const events = this.events;
      return function(node, newNode) {
        let nodeText = "-";
        let targetNode = newNode && newNode.text ? newNode : node;
        if (targetNode && targetNode.text) {
          nodeText = targetNode.text;
        }
        events.push(
          Object.assign({}, event, { time: new Date(), nodeText, id: key++ })
        );
      };
    },
    getArbolVistas() {
      this.loading = true;
      axios("/accesos/sistema/vistas/v1/")
        .then((response) => {
          if (response.data) {
            let data = response.data.resultado.vistas.map((item, index) => {
              return {
                id: item.idVista,
                idParent: item.idVistaPadre,
                text: item.nombre,
                data: item,
              };
            });
            this.data = JSON.unflatten(data, "id", "idParent");
            this.data.forEach((item) => {
              if (item.idParent == 0) {
                item.state = {
                  expanded: true,
                  draggable: false,
                };
              }
              this.instanceTree.append(item);
            });
            let rootNode = this.instanceTree.getRootNode();
            if (rootNode instanceof Array) {
              if (rootNode.length > 0) {
                rootNode[0].select(new Event("click"));
              }
            } else {
              rootNode.select(new Event("click"));
            }
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.$emit("noData", true);
          } else {
            console.log(error);
          }
          this.data = [];
        })
        .finally(() => {
          this.loading = false;
        });
    },
  },
  created() {
    self = this;
  },
};
</script>
